import React, { useState, useEffect } from 'react';
import { Form, Slider, Row, Col, Checkbox, Input, Button, InputNumber } from 'antd';
import router from 'umi/router';
import apis from '../../../../services/apis';
import request from '../../../../utils/request';
import ImageUploader from './ImageUpload';
import Styles from './styles.less';
import Navigate from '@/components/Navigate';
import BuildSelect from '../../../../components/SelectButton/BuildSelect2'

function Basic(props) {

    const { id, name } = props

    const [registrationInputValue, setRegistrationInputValue] = useState()

    const [viewProperty, setViewProperty] = useState(['index'])
    const [productionPoster, setProductionPoster] = useState(['index'])
    // const [registrationForm, setRegistrationForm] = useState([])
    const [inputVisible, setInputVisible] = useState(false)
    // const [registrationFormOption, setregistrationFormOption] = useState([
    //     { label: '姓名', value: 'name' },
    //     { label: '电话', value: 'tel' },
    //     { label: '自定义', value: 'abc' },
    // ])

    const [data, setData] = useState({})
    useEffect(() => {
        getList();
        console.log(props.id, '2341')
    }, [])
    // 查询列表

    const getList = () => {
        request({ ...apis.redPacket.detail, urlData: { id } }).then(data => {
            console.log(data, '2341')
            // s.split("==");
            data.buildingShowPos = data.buildingShowPos.split(',')

            data.buildingSposterShowPoshowPos = (data.posterShowPos).split(',')
            setViewProperty(data.buildingShowPos)
            setProductionPoster(data.posterShowPos)
            console.log(data, '2341')
            setData(data)
        })
    }

    const updateRedPacket = data => {
        request({ ...apis.redPacket.update, data: { ...data } }).then(data => {
            // setData(data)
        })
    }


    function handleSubmit(e) {
        e.preventDefault();
        props.form.validateFields((err, values) => {
            if (!err) {
                console.log(values, '------222-------')
                values.activityId = id
                // values.name = name
                values.buildingShowPos = values.buildingShowPos.toString()
                values.posterShowPos = values.posterShowPos.toString()
                console.log(values, '------222-------')
                updateRedPacket(values)
            }
        },
        )
    }

    function onViewPropertyChange(checkedValues) {
        console.log('checked = ', checkedValues);
        setViewProperty(checkedValues)
    }

    function onProductionPoster(checkedValues) {
        console.log('checked = ', checkedValues);
        setProductionPoster(checkedValues)
    }

    function onRegistrationForm(checkedValues) {
        console.log('checked = ', checkedValues);
        setRegistrationForm(checkedValues)
    }
    // registrationForm
    // function  (value, list) {
    //     return list.filter(f => f == value)
    // }
    function showInput() {
        setInputVisible(!inputVisible)
    }

    const handleInputChange = e => {
        setRegistrationInputValue(e.target.value)
        // this.setState({ inputValue: e.target.value });

    };

    const handleInputConfirm = () => {
        setregistrationFormOption([
            { label: '姓名', value: 'name' },
            { label: '电话', value: 'tel' },
            { label: registrationInputValue, value: 'abc' },
        ])


        setInputVisible(!inputVisible)
    }

    const { getFieldDecorator } = props.form

    return (

        <>
            <Form labelCol={{ span: 8 }} wrapperCol={{ span: 12 }} onSubmit={handleSubmit}>
                <Form.Item label="活动名称">
                    <span>{data.name}</span>
                </Form.Item>
                <Form.Item label="扫码查看" >
                    <img src={data.qrcode || ''} alt="" style={{ width: '100px' }} />
                </Form.Item>
                <Form.Item label="首页背景图" help="建议尺寸：750*1206px，格式:jpg；内容区大小：750*1150">
                    {getFieldDecorator('indexBackgroundImg',
                        {
                            initialValue: data.indexBackgroundImg,
                        })(
                            <ImageUploader />,
                        )}
                </Form.Item>
                <Form.Item label="分享海报图" help="建议尺寸：750*1206px，格式:jpg；内容区大小：750*1150">
                    {getFieldDecorator('sharePosterImg',
                        {
                            initialValue: data.sharePosterImg,
                        })(
                            <ImageUploader />,
                        )}
                </Form.Item>
                <Form.Item label="活动规则图" help="建议尺寸：750*1206px，格式:jpg">
                    {getFieldDecorator('activityRulesImg',
                        {
                            initialValue: data.activityRulesImg,
                        })(
                            <ImageUploader />,
                        )}
                </Form.Item>
                <Form.Item label="助力页背景图" help="建议尺寸：750*1206px，格式:jpg；内容区大小：750*1150">
                    {getFieldDecorator('helpBackgroundImg',
                        {
                            initialValue: data.helpBackgroundImg,
                        })(
                            <ImageUploader />,
                        )}
                </Form.Item>
                <Form.Item label="排行榜背景图" help="建议尺寸：750*1206px，格式:jpg；内容区大小：750*1150">
                    {getFieldDecorator('rankingBackgroundImg',
                        {
                            initialValue: data.rankingBackgroundImg,
                        })(
                            <ImageUploader />,
                        )}
                </Form.Item>
                <Form.Item label="上榜人数限制">
                    <Row>
                        <Col span={6}>
                            {getFieldDecorator('topLimitPersons',
                                {
                                    initialValue: typeof data.topLimitPersons === 'number' ? data.topLimitPersons : 0,
                                })(
                                    <Slider
                                        min={5}
                                        max={100}
                                        // value={typeof inputValue === 'number' ? inputValue : 0}
                                        step={1}
                                    // width="100px"
                                    // style={{ width: '100px' }}
                                    />,
                                )}
                        </Col>
                        <Col span={6}>
                            {getFieldDecorator('topLimitPersons',
                                {
                                    // initialValue: data.topLimitPersons,
                                })(
                                    <InputNumber
                                        min={5}
                                        max={100}
                                        style={{ marginLeft: 16 }}
                                    // value={inputValue}
                                    // onChange={this.onChange}
                                    />,
                                )}
                        </Col>
                    </Row>
                </Form.Item>
                <Form.Item label="查看楼盘按钮">
                    {getFieldDecorator('buildingShowPos',
                        {
                            initialValue: viewProperty,
                        })(
                            // <Checkbox.Group options={ViewProperty} defaultValue={['Apple']} onChange={onChange} />,style={viewProperty.indexOf('home') == -1 ? {} : { color: '#EF273A' }}
                            <Checkbox.Group name={Styles.Checkboxs} onChange={onViewPropertyChange} style={{ width: '100%' }}>
                                <Row>
                                    <Col span={6}>
                                        <Checkbox className={viewProperty.indexOf('index') === -1 ? {} : Styles.CheckboxStytle} value="index" >首页</Checkbox>
                                    </Col>
                                    <Col span={6}>
                                        <Checkbox className={viewProperty.indexOf('help') === -1 ? {} : Styles.CheckboxStytle} value="help">助力页</Checkbox>
                                    </Col>
                                    <Col span={6}>
                                        <Checkbox className={viewProperty.indexOf('rule') === -1 ? {} : Styles.CheckboxStytle} value="rule">活动规则页</Checkbox>
                                    </Col>
                                </Row>
                            </Checkbox.Group>,
                        )}
                </Form.Item>
                <Form.Item label="关联楼盘">
                    {getFieldDecorator('buildingId',
                        {
                            initialValue: data.buildingId,
                        })(
                            <BuildSelect />,
                        )}
                </Form.Item>
                <Form.Item label="生成海报按钮">
                    {getFieldDecorator('posterShowPos', {
                        initialValue: productionPoster,
                    })(
                        <Checkbox.Group name={Styles.Checkboxs} onChange={onProductionPoster} style={{ width: '100%' }}>
                            <Row>
                                <Col span={6}>
                                    <Checkbox className={productionPoster.indexOf('index') === -1 ? {} : Styles.CheckboxStytle} value="index" >首页</Checkbox>
                                </Col>
                                <Col span={6}>
                                    <Checkbox className={productionPoster.indexOf('help') === -1 ? {} : Styles.CheckboxStytle} value="help">助力页</Checkbox>
                                </Col>
                                <Col span={6}>
                                    <Checkbox className={productionPoster.indexOf('rule') === -1 ? {} : Styles.CheckboxStytle} value="rule">活动规则页</Checkbox>
                                </Col>
                            </Row>
                        </Checkbox.Group>,
                    )}
                </Form.Item>
                {/* <Form.Item label="报名表单">
                    {getFieldDecorator('registrationForm')(
                        <Checkbox.Group name={Styles.Checkboxs} onChange={onRegistrationForm} style={{ width: '100%' }}>
                            <Row>
                                {registrationFormOption.map((x, index) => {
                                    return <Col span={6}>
                                        {index !== 2 && (<Checkbox className={registrationForm.indexOf(x.value) === -1 ? {} : Styles.CheckboxStytle} value={x.value} >{x.label} </Checkbox>)}

                                        {inputVisible && index === 2 && (
                                            <Input
                                                // ref={this.saveInputRef}
                                                type="text"
                                                size="small"
                                                style={{ width: 78 }}
                                                // value={inputValue}
                                                onChange={handleInputChange}
                                                onBlur={handleInputConfirm}
                                                onPressEnter={handleInputConfirm}
                                            />
                                        )}
                                        {!inputVisible && index === 2 && (
                                            <Checkbox className={registrationForm.indexOf(x.value) === -1 ? {} : Styles.CheckboxStytle} value={x.value} >{x.label} </Checkbox>
                                        )}
                                        {!inputVisible && index === 2 && x.label === '自定义' && (
                                            <Navigate onClick={showInput} >
                                                修改
                                            </Navigate>
                                        )}
                                    </Col>
                                })}
                            </Row>
                          
                        </Checkbox.Group>,
                    )}
                </Form.Item> */}
                <Form.Item wrapperCol={{ span: 15, offset: 8 }}>
                    <div style={{ width: '190px' }}>
                        <Button type="primary" style={{ marginRight: '20px' }} htmlType="submit">保存</Button>
                        {/* <Button onClick={() => router.go(-1)} >取消</Button> */}
                    </div>
                </Form.Item>
            </Form>
        </>

    )
}

const WrappedBasic = Form.create({ name: 'Basic' })(Basic);

export default WrappedBasic
